(HDU

来源:互联网 发布:ios系统解压缩软件 编辑:程序博客网 时间:2024/06/03 21:35

(HDU - 4283)You Are the One

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4411 Accepted Submission(s): 2066

Problem Description

  The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?

Input

  The first line contains a single integer T, the number of test cases. For each case, the first line is n (0 < n <= 100)
  The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)

Output

  For each test case, output the least summary of unhappiness .

Sample Input

2
  
5
1
2
3
4
5

5
5
4
3
2
2

Sample Output

Case #1: 20
Case #2: 24

题目大意:有一群排队的人每个人都有一个屌丝值ai,第k个上场的人会因为要等k-1个人而产生(k-1)*a[k]的愤怒值,现有一个小黑屋,类似于栈(先进后出),可以改变这些人的出厂顺序,要使这些人的愤怒值尽可能小,问这个最小愤怒值为多少。

思路:设f[i][j]表示第i个到第j个人这段区间的最小愤怒值。在区间[i,j]上,研究i这个人,假设i这个人是第k个上场(1<=k<=j-i+1),则第一个上场的是i+k-1。考虑这样安排对愤怒值的影响:首先i这个人会有a[i]*(k-1)的愤怒值,区间[i+k,j]会因为多等前面k个人而多产生k(a[i+k]+a[i+k+1]++a[j])的愤怒值。综上可能状态转移方程为f[i][j]=min(f[i][j],(k1)a[i]+f[i+1][i+k1]+f[i+k][j]+ksum[j]sum[i+k1]))。(其中a数组记录每个人的屌丝值,sum数组为屌丝值的前缀和)

递推写法:

#include<cstdio>#include<cstring>#include<algorithm>using namespace std;const int INF=0x3f3f3f3f;const int maxn=105;int a[maxn],sum[maxn],f[maxn][maxn];int main(){    int T,kase=1;    scanf("%d",&T);    while(T--)    {        int n;        scanf("%d",&n);        sum[0]=0;        for(int i=1;i<=n;i++)        {            scanf("%d",a+i);            sum[i]=sum[i-1]+a[i];            f[i][i]=0;        }        for(int l=2;l<=n;l++)            for(int i=1;i+l-1<=n;i++)            {                int j=i+l-1;                f[i][j]=INF;                for(int k=1;k<=j-i+1;k++)                    f[i][j]=min(f[i][j],(k-1)*a[i]+f[i+1][i+k-1]+f[i+k][j]+k*(sum[j]-sum[i+k-1]));            }        printf("Case #%d: %d\n",kase++,f[1][n]);    }    return 0;}

记忆化搜索写法:

#include<cstdio>#include<cstring>#include<algorithm>using namespace std;const int INF=0x3f3f3f3f;const int maxn=105;int a[maxn],f[maxn][maxn],pre[maxn];int dfs(int i,int j){    if(f[i][j]!=-1) return f[i][j];    if(i>=j) return 0;    int ans=INF;    for(int k=1;k<=j-i+1;k++)        ans=min(ans,dfs(i+1,i+k-1)+dfs(i+k,j)+(k-1)*a[i]+k*(pre[j]-pre[i+k-1]));    f[i][j]=ans;    return ans; }int main(){    int T,kase=1;    scanf("%d",&T);    while(T--)    {        int n;        scanf("%d",&n);        pre[0]=0;        for(int i=1;i<=n;i++)        {            scanf("%d",a+i);            pre[i]=pre[i-1]+a[i];        }        memset(f,-1,sizeof(f));        printf("Case #%d: %d\n",kase++,dfs(1,n));    }    return 0;}